### Nested Logit estimation program (Original code by EHIME University)
###f[^t@C̓ǂݍ
Data<-read.csv("C:/Users/t.udo/Documents/2019Ă̊wZ/06 NL estimation.csv",header=T)
hh<-nrow(Data) ##f[^:Data ̍s𐔂
print(hh)
ch<- 3 ##pI̐
b0<-c(0, 0, 0, 0,0,0,0,0, 1)
Srail <- sum(Data[,2]=="rail"); Sbus <- sum(Data[,2]=="bus"); Scar <- sum(Data[,2]=="car")
cat("rail:",Srail," bus:",Sbus," car:",Scar,"\n")
## Logit model ̑ΐޓx֐̒`
fr <- function(x) {
  LL=0
  ##p̌vZ
  rail <-  x[1]*matrix(1,nrow =hh,ncol=1)  +x[3]*Data[,6]/10   +  x[5]*Data[, 7]/100                          +  x[7]*(Data[, 3]==2)    # 
  bus <-   x[2]*matrix(1,nrow=hh,ncol=1)   +x[3]*Data[,8]/10  +  x[5]*Data[, 9]/100    + x[6]*(Data[, 3]>=4)                        + x[8]*(Data[, 4]==1)       #  x[1]*Data[, 9]/10
  car <-                                    x[4]*Data[,10]/10                          + x[6]*(Data[, 3]>=4)                        + x[8]*(Data[, 4]==1)
  ##p̎w
  Erail <- exp(rail)
  Ebus <- exp(bus )
  Ecar <- exp(car )
  
  LSrb <- exp( x[9]*log( Erail + Ebus ) )
  LSc <- exp( x[9]*log( Ecar ) )
  PPrail <- Erail/(Erail+Ebus) * LSrb/(LSrb + LSc)
  PPbus <- Ebus /(Erail+Ebus) * LSrb/(LSrb + LSc)
  PPcar <- LSc/(LSrb + LSc)
  
  #LSr <- exp( x[7]*log( Erail ) )
  #LSbc <- exp( x[7]*log( Ebus + Ecar ) )
  #PPrail <- LSr/(LSr + LSbc)
  #PPbus <- Ebus /(Ebus+Ecar) * LSbc/(LSr + LSbc)
  #PPcar <- Ecar /(Ebus+Ecar) * LSbc/(LSr + LSbc)
  
  #LSrc <- exp( x[8]*log( Erail+ Ecar ) )
  #LSb <- exp( x[8]*log( Ebus ) )
  #PPrail <- Erail/(Erail+Ecar) * LSrc/(LSrc + LSb)
  #PPbus <- LSb/(LSrc + LSb)
  #PPcar <- Ecar /(Erail+Ecar) * LSrc/(LSrc + LSb)
  ##Iʂ̊m݂̂L
  Prail <- (PPrail!=0)*PPrail + (PPrail==0)
  Pbus <- (PPbus !=0)*PPbus + (PPbus ==0)
  Pcar <- (PPcar !=0)*PPcar + (PPcar ==0)
  ##I
  Crail <- Data[,2]=="rail"
  Cbus <- Data[,2]=="bus"
  Ccar <- Data[,2]=="car"
  ##ΐޓx̌vZ
  LL <- colSums( Crail*log(Prail) + Cbus*log(Pbus) + Ccar*log(Pcar) )
  
  return(LL)
}
## ΐޓx֐fr ̍ő剻
res<-optim(b0,fr, method = "BFGS", hessian = TRUE, control=list(fnscale=-1))
## estimated parameter
b<-res$par
hhh<-res$hessian
## t ľvZ
tval<-b/sqrt(-diag(solve(hhh)))
##ޓx
L0 <- Srail*log(Srail/hh)+Sbus*log(Sbus/hh)+Scar*log(Scar/hh)
##ŏIޓx
LL <- res$value
## Kx̌vZ
##ʂ̏o
##^2 l
cat(" roh = ",(L0-LL)/L0,"\n")
##Cσ^2 l
cat(" rohbar= ",(L0-(LL-length(b)))/L0,"\n")
print(res)
print(tval)
